unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    ColorDialog1: TColorDialog;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Color1, Color2 : TColor;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
 if ColorDialog1.Execute then begin
  Color1:=ColorDialog1.Color;
  Label1.Color:=Color1;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if ColorDialog1.Execute then begin
  Color2:=ColorDialog1.Color;
  Label2.Color:=Color2;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Color1:=clWhite;
 Label1.Color:=Color1;
 ColorDialog1.Color:=clWhite;
 Color2:=clBlack;
 Label2.Color:=Color2;
end;

procedure ExtractColors (C:TColor; var r,g,b:integer);
var s:String[8]; sr:String[3];
begin
 s:=IntToHex (C,6);
 sr:='$'+Copy(s,1,2); r:=StrToInt (sr);
 sr:='$'+Copy(s,3,2); g:=StrToInt (sr);
 sr:='$'+Copy(s,5,2); b:=StrToInt (sr);
end;

procedure ExtractSteps (size,color1,color2:integer; var delta,znak:integer);
var d:integer;
begin
 if color1>color2 then znak:=-1
 else znak:=1;
 d:=abs(color1-color2);
 if d=0 then begin
  znak:=0; delta:=0; exit;
 end
 else begin
  if size>d then delta:=size div d
  else delta:=d div size;
 end;
end;

procedure DoStep (r1,r2,dr,zr:integer; var r,cr:integer);
begin
  inc(cr);
  if cr=dr then begin
   cr:=0;
   if (zr<0) and (r>0) then dec(r)
   else if (zr>0) and (r<r2) then inc(r);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var r1,g1,b1,r2,g2,b2,dx,dy,dr,dg,db,zr,zg,zb,r,g,b,cr,cg,cb,i:integer;
begin
 ExtractColors (Color1,r1,g1,b1);
 ExtractColors (Color2,r2,g2,b2);
 dx:=Form1.ClientWidth;
 dy:=Form1.ClientHeight;
 ExtractSteps (dy,r1,r2,dr,zr);
 ExtractSteps (dy,g1,g2,dg,zg);
 ExtractSteps (dy,b1,b2,db,zb);
 r:=r1; g:=g1; b:=b1;
 cr:=0; cg:=0; cb:=0;
 for i:=1 to dy do begin
  Form1.Canvas.Pen.Color:=RGB(r,g,b);
  DoStep (r1,r2,dr,zr,r,cr);
  DoStep (g1,g2,dg,zg,g,cg);
  DoStep (b1,b2,db,zb,b,cb);
  Form1.Canvas.MoveTo (0,i);
  Form1.Canvas.LineTo (dx,i);
 end;
 Form1.Color:=RGB(r1,g1,b1);
end;

end.
