{ }
unit MDIEdit;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls;

type
  TEditForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Selectall1: TMenuItem;
    Character1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Center1: TMenuItem;
    N4: TMenuItem;
    Wordwrap1: TMenuItem;
    N5: TMenuItem;
    Font1: TMenuItem;
    Editor: TRichEdit; { TRichEdit -   }
    PopupMenu1: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    SaveFileDialog: TSaveDialog;
    FontDialog1: TFontDialog;
    Printersetup1: TMenuItem;
    Close1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    N1: TMenuItem;
    FindDialog1: TFindDialog;
    N6: TMenuItem;
    Find1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure AlignClick(Sender: TObject);
    procedure Wordwrap1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Printersetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure Find1Click(Sender: TObject);
  private
    { Private declarations }
    PathName: string;
  public
    { Public declarations }
    procedure Open(const AFileName: string);
  end;

var
  EditForm: TEditForm;

const {   }
  DefaultFileName = ' .rtf';

implementation

uses Clipbrd, //  
     Printers, // 
     MDIFrame; //  

{$R *.DFM}

procedure TEditForm.Exit1Click(Sender: TObject);
begin { ,   -     FrameForm}
  FrameForm.Exit1Click(Sender);
end;

procedure TEditForm.New1Click(Sender: TObject);
begin { ,   -     FrameForm}
  FrameForm.New1Click(Sender);
end;

procedure TEditForm.Open1Click(Sender: TObject);
begin { ,   -     FrameForm}
  FrameForm.Open1Click(Sender);
end;

procedure TEditForm.AlignClick(Sender: TObject);
begin  {      ,  ,  -
   }
  Left1.Checked := False;   {  }
  Right1.Checked := False;
  Center1.Checked := False;
  with Sender as TMenuItem do Checked := True;
  {   }
  with Editor.Paragraph do {   }
    { c   }
    if Left1.Checked then
      Alignment := taLeftJustify {  }
    else if Right1.Checked then
      Alignment := taRightJustify {  }
    else if Center1.Checked then
      Alignment := taCenter; { }
end;

procedure TEditForm.Wordwrap1Click(Sender: TObject);
begin { , .   }
  with Editor do
  begin
    WordWrap := not WordWrap; {         TRichEdit }
    if WordWrap=true then {  ,     }
      ScrollBars := ssVertical
    else
      ScrollBars := ssBoth; {  }
    WordWrap1.Checked := WordWrap; {        }
  end;
end;

procedure TEditForm.Cut1Click(Sender: TObject);
begin { ,   -   }
  Editor.CutToClipboard;
end;

procedure TEditForm.Copy1Click(Sender: TObject);
begin { ,   -   }
  Editor.CopyToClipboard;
end;

procedure TEditForm.Paste1Click(Sender: TObject);
begin { ,   -   }
  Editor.PasteFromClipboard;
end;

procedure TEditForm.Selectall1Click(Sender: TObject);
begin { ,    -    }
  Editor.SelectAll;
end;

procedure TEditForm.Delete1Click(Sender: TObject);
begin { ,   -   }
  Editor.ClearSelection;
end;

procedure TEditForm.Edit1Click(Sender: TObject);
var
  HasSelection: Boolean;
begin
  Paste1.Enabled := Clipboard.HasFormat(CF_TEXT);
  Paste2.Enabled := Paste1.Enabled;
  HasSelection := Editor.SelLength > 0;
  Cut1.Enabled := HasSelection;
  Cut2.Enabled := HasSelection;
  Copy1.Enabled := HasSelection;
  Copy2.Enabled := HasSelection;
  Delete1.Enabled := HasSelection;
end;

procedure TEditForm.Open(const AFileName: string);
begin {  ,     }
  PathName := AFileName;
  Caption := ExtractFileName(AFileName);
   {    =  }
  with Editor do begin
    Lines.LoadFromFile(PathName); {   }
    SelStart := 0; {  }
    Modified := False; { "  "}
  end;
end;

procedure TEditForm.Saveas1Click(Sender: TObject);
begin { ,   }
  SaveFileDialog.FileName := PathName;
  {   ,      
    PathName -     ...}
  if SaveFileDialog.Execute then {   ,}
  begin
    PathName := SaveFileDialog.FileName; {  }
    if Pos('.rtf',PathName)=0 then PathName:=PathName+'.rtf';
    Caption := ExtractFileName(PathName); {      }
    Save1Click(Sender); {   }
  end;
end;

procedure TEditForm.Save1Click(Sender: TObject);
begin { ,  }
  if PathName = DefaultFileName then
   {    -      ...}
    SaveAs1Click(Sender)
  else
  begin
    Editor.Lines.SaveToFile(PathName); {     RichEdit}
    Editor.Modified := False; {  ""  -
    ..        }
  end;
end;

procedure TEditForm.Font1Click(Sender: TObject);
begin { ,  ...}
  FontDialog1.Font := Editor.Font;
   {       }
  if FontDialog1.Execute then {    }
    Editor.SelAttributes.Assign(FontDialog1.Font);
     {     !}
end;

procedure TEditForm.Close1Click(Sender: TObject);
begin { ,  }
  Close;
end;

procedure TEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin {,     }
  Action := caFree; { }
{   :
 caNone       -   
 caHide      -   
 caMinimize) -    }
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const {,      }
  SWarningText = '    "%s"?';
begin
  if Editor.Modified then {  }
  begin
    case MessageDlg(Format(SWarningText, [PathName]), mtConfirmation,
      [mbYes, mbNo, mbCancel], 0) of {  }
      idYes:    Save1Click(Self); {  -   }
      idCancel: CanClose := False; {  -   " "}
    end;
  end;
end;

procedure TEditForm.FormCreate(Sender: TObject);
begin {   -     }
  PathName := DefaultFileName;
end;

procedure TEditForm.Printersetup1Click(Sender: TObject);
begin { ,   ...}
  PrinterSetupDialog1.Execute;
end;

procedure TEditForm.Print1Click(Sender: TObject);
begin { ,  }
  if PrintDialog1.Execute then
    Editor.Print(PathName);
end;

procedure TEditForm.FindDialog1Find(Sender: TObject);
var
  FoundAt: LongInt;
  StartPos, ToEnd: integer;
begin
  with Editor do begin
    StartPos := 0;
    ToEnd := Length(Text);
    FoundAt := FindText(FindDialog1.FindText, StartPos, ToEnd,
     [stMatchCase]);
    if FoundAt <> -1 then begin
      SetFocus;
      SelStart := FoundAt;
      StartPos := SelStart;
      ScrollBy (0,StartPos);
      SelLength := Length(FindDialog1.FindText);
    end;
  end;
end;

procedure TEditForm.Find1Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

end.
